<?php
namespace Geral\Entities;

use Geral\Util\DateUtil;
use Planejamento\Entities\Custpadr;
use Planejamento\Entities\Custpadrtp;
use Setforms2\Shared\Registry;
use \Geral\Util\Ambiente;
use Geral\Util\TratamentoDeMensagens;
use Planejamento\Entities\Confcard;



class Servico extends Base\Servico
{

    CONST DOM      = 1;
    CONST SEG      = 2;
    CONST TER      = 3;
    CONST QUA      = 4;
    CONST QUI      = 5;
    CONST SEX      = 6;
    CONST SAB      = 7;
    CONST NAO_UTIL = 8;
    CONST FER      = 9;


    public function atualizaComensaisEstimados(
        $nrorg, $dia, $cliente, $funcionario, $doacao, $operador
    )
    {
        switch ($dia) {
        case self::DOM:
            $this->setQtcliestidom($cliente);
            $this->setQtfunestidom($funcionario);
            $this->setQtdoaestidom($doacao);
            $this->setQtcomestidom($doacao + $funcionario + $cliente);
            break;
        case self::SEG:
            $this->setQtcliestiseg($cliente);
            $this->setQtfunestiseg($funcionario);
            $this->setQtdoaestiseg($doacao);
            $this->setQtcomestiseg($doacao + $cliente + $funcionario);
            break;
        case self::TER:
            $this->setQtcliestiter($cliente);
            $this->setQtfunestiter($funcionario);
            $this->setQtdoaestiter($doacao);
            $this->setQtcomestiter($doacao + $funcionario + $cliente);
            break;
        case self::QUA:
            $this->setQtcliestiqua($cliente);
            $this->setQtfunestiqua($funcionario);
            $this->setQtdoaestiqua($doacao);
            $this->setQtcomestiqua($doacao + $cliente + $funcionario);
            break;
        case self::QUI:
            $this->setQtcliestiqui($cliente);
            $this->setQtfunestiqui($funcionario);
            $this->setQtdoaestiqui($doacao);
            $this->setQtcomestiqui($doacao + $funcionario + $cliente);
            break;
        case self::SEX:
            $this->setQtcliestisex($cliente);
            $this->setQtfunestisex($funcionario);
            $this->setQtdoaestisex($doacao);
            $this->setQtcomestisex($doacao + $funcionario + $cliente);
            break;
        case self::SAB:
            $this->setQtcliestisab($cliente);
            $this->setQtfunestisab($funcionario);
            $this->setQtdoaestisab($doacao);
            $this->setQtcomestisex($cliente + $doacao + $funcionario);
            break;
        case self::FER:
            $this->setQtcliestifer($cliente);
            $this->setQtfunestifer($funcionario);
            $this->setQtdoaestifer($doacao);
            $this->setQtcomestifer($doacao + $cliente + $doacao);
            break;
        }

        $this->setNrorgultatu($nrorg);
        $this->setCdoperultatu($operador);
        $this->setDtultatu(DateUtil::getDataAtual(true));

        $this->persist();
    }


    public static function atualizaParametrosServico(
        $nrorg, $filial, $servico, $horapreparo, $alteracao, $idconsumidor,
        $idcliente,  $diasantes, $diasapos, $notificacao, $hrsalteracao,
        $acrescimo, $reducao, $diasalteracao, $email, $operador
    )
    {
        try {
            $serv = self::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
                array($nrorg, $filial, $servico)
            );

            if ($serv instanceof Servico) {
                $dtAtual = DateUtil::getDataAtual();

                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $serv->setIdformaltera($alteracao);
                $serv->setHrinicaten($horapreparo);
                $serv->setDsemailnotif($email);
                $serv->setIdconsumidor($idconsumidor);
                $serv->setIdcliente($idcliente);
                $serv->setNrdiasant($diasantes);
                $serv->setNrdiaspos($diasapos);
                $serv->setIdnotificarefe($notificacao);
                $serv->setHralteracli($hrsalteracao);
                $serv->setVracrescimo($acrescimo);
                $serv->setVrreducao($reducao);
                $serv->setNrdiasalt($diasalteracao);
                $serv->setNrorgultatu($nrorg);
                $serv->setCdoperultatu($operador);
                $serv->setDtultatu($dtAtual);

                $serv->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function getListaServicos($nrorg, $agregadas)
    {
        $servicos = array();
        foreach ($agregadas as $item) {
            $filial  = $item->getCdfilial();
            $servico = Servico::getObjectsByWhere(
                'NRORG = ? AND CDFILIAL = ? AND IDSERVTRAN = ?',
                array(
                    $nrorg, $filial, 'S'
                )
            );
            foreach ($servico as $serv) {
                array_push($servicos, $serv);
            }
        }
        return $servicos;
    }

    /**
     * Retorna os dados de formulário para a exportação de configuração padrão
     *
     * @param String $nrorg      Organização
     * @param String $cdfilial   Unidade
     * @param String $cdservfili Serviço
     *
     * @return mixed
     * @throws \Exception
     */
    public static function getDadosFormulario($nrorg, $cdfilial, $cdservfili)
    {
        try {
            /** @var Servico $formulario Formulário */
            $formulario = self::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
                array($nrorg, $cdfilial, $cdservfili)
            );      return $formulario ;
        } catch (\Exception $e) {
            throw $e;
        }
    }


    public static function atualizaParametrosNovoServico(
        $regModelo,
        $nrorg, $filial, $grupserv, $cdservico, $nmservico, $cdproduto,                                                          $iniciopreparo, $idconsumidor, $idfatuserv,$idtiposerv,
        $cdrotatrans, $hrfinaserv, $idservtran, $vrpesocusto,
        $idconsservca, $idservprinc, $idutretiprat, $idtpservhosp,
        $cdserpaddie, $idservativ, $idbloqaltpra, $idconscomfat,
        $idvlrvardata, $cdservprequi, $idservfatsep, $idbloqconfixper,
        $hreentrega, $idcliente, $diasantes, $diasapos, $notificacao,
        $hrsalteracao, $acrescimo, $reducao, $diasalteracao, $email,
        $idindicador, $idaltcomensais, $hrinicserv, $cdservdos,
        $idcarddescentr, $idutpratrelac, $idcardconsumidorweb, $idativo,
        $dsemailnotif, $idformaltera
    ){
        try {

            /** @var $serv Servico*/
            $serv = new Servico;

            $operador = Ambiente::getCdOperador();
            $dtAtual = DateUtil::getDataAtual();

            $serv->setDtinclusao($dtAtual);
            $serv->setNmservicoredu($nmservico);
            $serv->setDtultatu($dtAtual);
            $serv->setCdoperinclusao($operador);
            $serv->setCdoperultatu($operador);
            $serv->setNrorginclusao($nrorg);
            $serv->setNrorgultatu($nrorg);


            $serv->setNrorg($nrorg); $serv->setCdfilial($filial);
            $serv->setGrupserv($grupserv); $serv->setCdservfili($cdservico);
            $serv->setNmservico($nmservico); $serv->setCdproduto($cdproduto);
            $serv->setHrinicaten($iniciopreparo); $serv->setIdfatuserv($idfatuserv);
            $serv->setIdtiposerv($idtiposerv); $serv->setCdrotatrans($cdrotatrans);
            $serv->setHrfinaserv($hrfinaserv); $serv->setIdservtran($idservtran);
            $serv->setVrpesocusto($vrpesocusto); $serv->setIdconsservca($idconsservca);
            $serv->setIdservprinc($idservprinc); $serv->setIdutretiprat($idutretiprat);
            $serv->setIdtpservhosp($idtpservhosp); $serv->setCdserpaddie($cdserpaddie);
            $serv->setIdservativ($idservativ); $serv->setIdbloqaltpra($idbloqaltpra);
            $serv->setIdconscomfat($idconscomfat); $serv->setIdvlrvardata($idvlrvardata);
            $serv->setCdservprequi($cdservprequi); $serv->setIdservfatsep($idservfatsep);
            $serv->setIdbloqconfixper($idbloqconfixper); $serv->setHrentrega($hreentrega);
            $serv->setIdconsumidor($idconsumidor); $serv->setIdcliente($idcliente);
            $serv->setNrdiasant($diasantes); $serv->setNrdiaspos($diasapos);
            $serv->setIdnotificarefe($notificacao); $serv->setHralteracli($hrsalteracao);
            $serv->setVracrescimo($acrescimo); $serv->setVrreducao($reducao);
            $serv->setNrdiasalt($diasalteracao); $serv->setDsemailnotif($email);
            $serv->setIdindicador($idindicador); $serv->setIdaltcomensais($idaltcomensais);
            $serv->setHrinicserv($hrinicserv); $serv->setCdservdos($cdservdos);
            $serv->setIdcarddescentr($idcarddescentr);
            $serv->setIdutpratrelac($idutpratrelac); $serv->setIdcardconsumidorweb($idcardconsumidorweb);
            $serv->setIdativo($idativo); $serv->setDsemailnotif($dsemailnotif);
            $serv->setIdformaltera($idformaltera);

            $serv->clonaComensais($regModelo, $serv);


            return $serv;



        } catch (\Exception $e) {
            throw $e;
        }
    }


    public static function incluiAutomaticamenteServico($cdservicomodelo, $cdfilial, $novasrowspadraoservico){

        $conn = Registry::getEntityManager();

        $codigospadraoservico = array();
        $nomespadraoservico = array();

        foreach($novasrowspadraoservico as $rowpadraoservico){
            foreach($rowpadraoservico as $indice=>$campopadraoservico){

                if($indice=='CDSERVPADR' && !empty($rowpadraoservico[$indice])
                    || $indice == 'CDSERVPADR1' && !empty($rowpadraoservico[$indice]))
                {
                    array_push($codigospadraoservico, $campopadraoservico);
                }

                if($indice=='NMSERVPADR' && !empty($rowpadraoservico[$indice])
                    || $indice == 'NMSERVPADR1' && !empty($rowpadraoservico[$indice]))
                {
                    array_push($nomespadraoservico, $campopadraoservico);
                }

            }
        }

        try{
            $nrorg = Ambiente::getNrorg();

            /** @var $regModelo Servico */

            $regModelo = self::getObjectByWhere(
                "CDSERVFILI = ? AND NRORG = ? AND CDFILIAL = ?", array($cdservicomodelo, $nrorg, $cdfilial)
            );

            $reg = array();

            if($regModelo instanceof Servico){

                foreach($codigospadraoservico as $indice=>$campopadraoservico){
                    $conn->beginTransaction();
                    $reg[$indice] = new Servico;
                    $reg[$indice] = $regModelo->atualizaParametrosNovoServico(
                        $regModelo,
                        $nrorg,
                        $cdfilial,
                        $regModelo->getGrupserv(),
                        $campopadraoservico,
                        $nomespadraoservico[$indice],
                        $regModelo->getCdproduto(),
                        $regModelo->getHrinicaten(),
                        $regModelo->getIdconsumidor(),
                        $regModelo->getIdfatuserv(),
                        $regModelo->getIdtiposerv(),
                        $regModelo->getCdrotatrans(),
                        $regModelo->getHrfinaserv(),
                        $regModelo->getIdservtran(),
                        $regModelo->getVrpesocusto(),
                        $regModelo->getIdconsservca(),
                        $regModelo->getIdservprinc(),
                        $regModelo->getIdutretiprat(),
                        $regModelo->getIdtpservhosp(),
                        $regModelo->getCdserpaddie(),
                        $regModelo->getIdservativ(),
                        $regModelo->getIdbloqaltpra(),
                        $regModelo->getIdconscomfat(),
                        $regModelo->getIdvlrvardata(),
                        $regModelo->getCdservprequi(),
                        $regModelo->getIdservfatsep(),
                        $regModelo->getIdbloqconfixper(),
                        $regModelo->getHrentrega(),
                        $regModelo->getIdcliente(),
                        $regModelo->getNrdiasant(),
                        $regModelo->getNrdiaspos(),
                        $regModelo->getIdnotificarefe(),
                        $regModelo->getHralteracli(),
                        $regModelo->getVracrescimo(),
                        $regModelo->getVrreducao(),
                        $regModelo->getNrdiasalt(),
                        $regModelo->getDsemailnotif(),
                        $regModelo->getIdindicador(),
                        $regModelo->getIdaltcomensais(),
                        $regModelo->getHrinicserv(),
                        $regModelo->getCdservdos(),
                        $regModelo->getIdcarddescentr(),
                        $regModelo->getIdutpratrelac(),
                        $regModelo->getIdcardconsumidorweb(),
                        $regModelo->getIdativo(),
                        $regModelo->getDsemailnotif(),
                        $regModelo->getIdformaltera()

                    );



                    $reg[$indice]->persist();
                    $conn->flush();
                    $conn->commit();

                    Confcard::clonaConfcard($regModelo, $reg[$indice], $conn);
                    Custpadr::clonaCustpadr($regModelo, $reg[$indice], $conn);
                    Custpadrtp::clonaCustpadrtp($regModelo, $reg[$indice], $conn);
                    Turnoserv::clonaTurnoserv($regModelo, $reg[$indice], $conn);



                }
            }

        }catch(\Exception $e){
            $conn->rollback();
            TratamentoDeMensagens::exibirMensagens($e, true);
        }


    }

    public static function clonaComensais (Servico $regModelo, Servico $regNovo){

        $regNovo->setQtcomestiseg( $regModelo->getQtcomestiseg() );
        $regNovo->setQtcomestiter( $regModelo->getQtcomestiter() );
        $regNovo->setQtcomestiqua( $regModelo->getQtcomestiqua() );
        $regNovo->setQtcomestiqui( $regModelo->getQtcomestiqui() );
        $regNovo->setQtcomestisex( $regModelo->getQtcomestisex() );
        $regNovo->setQtcomestisab( $regModelo->getQtcomestisab() );
        $regNovo->setQtcomestidom( $regModelo->getQtcomestidom() );
        $regNovo->setQtcomestifer( $regModelo->getQtcomestifer() );
        $regNovo->setQtcliestiseg( $regModelo->getQtcliestiseg() );
        $regNovo->setQtcliestiter( $regModelo->getQtcliestiter() );
        $regNovo->setQtcliestiqua( $regModelo->getQtcliestiqua() );
        $regNovo->setQtcliestiqui( $regModelo->getQtcliestiqui() );
        $regNovo->setQtcliestisex( $regModelo->getQtcliestisex() );
        $regNovo->setQtcliestisab( $regModelo->getQtcliestisab() );
        $regNovo->setQtcliestidom( $regModelo->getQtcliestidom() );
        $regNovo->setQtcliestifer( $regModelo->getQtcliestifer() );
        $regNovo->setQtfunestiseg( $regModelo->getQtfunestiseg() );
        $regNovo->setQtfunestiter( $regModelo->getQtfunestiter() );
        $regNovo->setQtfunestiqua( $regModelo->getQtfunestiqua() );
        $regNovo->setQtfunestiqui( $regModelo->getQtfunestiqui() );
        $regNovo->setQtfunestisex( $regModelo->getQtfunestisex() );
        $regNovo->setQtfunestisab( $regModelo->getQtfunestisab() );
        $regNovo->setQtfunestidom( $regModelo->getQtfunestidom() );
        $regNovo->setQtfunestifer( $regModelo->getQtfunestifer() );
        $regNovo->setQtdoaestiseg( $regModelo->getQtdoaestiseg() );
        $regNovo->setQtdoaestiter( $regModelo->getQtdoaestiter() );
        $regNovo->setQtdoaestiqua( $regModelo->getQtdoaestiqua() );
        $regNovo->setQtdoaestiqui( $regModelo->getQtdoaestiqui() );
        $regNovo->setQtdoaestisex( $regModelo->getQtdoaestisex() );
        $regNovo->setQtdoaestisab( $regModelo->getQtdoaestisab() );
        $regNovo->setQtdoaestidom( $regModelo->getQtdoaestidom() );
        $regNovo->setQtdoaestifer( $regModelo->getQtdoaestifer() );
    }

    public static function retornaNomeServico($cdfilial, $nrorg, $cdservfili){
        /**
         * @var \Geral\Entities\Servico $servico Servico
         */
        $servico = Servico::getObjectByWhere('CDFILIAL = ? AND NRORG =? AND CDSERVFILI =?',array($cdfilial,$nrorg, $cdservfili));
        $nome = $servico ->getNmservico();

        return $nome;
    }




}